{ SendMail Example Project

  Author:  Lars (L505)

  Website: http://z505.com


  IMPORTANT:
   - you must have sendmail installed

   - please enter your email address below in place of "youraddress@yahoo.com"
     and then compile the program

   - also check your send mail path. it is defined in SendMail.pas as a CONST


  Note: if you attach NO files at all with WebSendMail_PA, it will still send
        email (setlength effectively at 0). The email will show that you wished
        to attach files, but none will be there when the user looks to open
        them.  (you could have used WebSendMail_P or WebSendMail instead, which
        would be more optimal if you are not attaching any files).

   If you try to send an email with an attachment who's file does not
   exist, the email will not even be attempted to be sent. You will receive
   an error telling you the file cannot be found.
}


program EmailTest;

{$mode objfpc}{$H+}

uses
  SendMail,  // SendMail functions
  strwrap1;  // some nice string utils

  
var
  AttachedFile: TEmailAttachments;
  
begin




  writeln('Demonstrating SendMail functions... ');


{------------------------------------------------------------------------------}
{-------- TEST 1 --------------------------------------------------------------}
{------------------------------------------------------------------------------}
// Send a simple email with high priority


  SendMail_P([High],
             'mailform@youraddress.com',
             'youraddress@yahoo.com', //your email address
             'Testing first P function',
              StrLoadFile('messageTEXT.txt')
             );

{------------------------------------------------------------------------------}



{------------------------------------------------------------------------------}
{-------- TEST 2 --------------------------------------------------------------}
{------------------------------------------------------------------------------}
// Send an email with attachments and low priority


  SetLength(AttachedFile, 1); // only one file to attach
  AttachedFile[0].FileName:= 'MyAttachment.txt';

  // specify your file type here if you want to. Otherwise, the email client
  // should figure it out
  { AttachedFile[0].FileType:= 'application/txt'; }

  // you do not need to worry about Disposition if you are sending a regular
  // attached file. If you are sending an embedded image or inline attachment,
  // go like so:
  {  AttachedFile[0].Disposition:= 'inline';}

  { SetLength(AttachedFile, 2); // want to attache more files?
    AttachedFile[1].FileName:= 'myfile.txt';
    AttachedFile[1].FileType:= 'application/x-zip-compressed'; }

  // Let's set the default email type to html formatted emails for the second test.
  // Plain text was the default used on the first mailing above.
  EmailBodyType:= [HTML];
  

  SendMail_PA([Low],
              AttachedFile,
              'mailform@youraddress.com',
              'youraddress@yahoo.com', //your email address
              'Testing second PA function',
               StrLoadFile('messageHTML.txt')
             );

{------------------------------------------------------------------------------}


  writeln('done. check your email now. <enter>');
  readln;


end.

