{
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

                       SendMail for Pascal Programs

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 ------------------------------------------------------------------------------
  MailPrep Unit
 ------------------------------------------------------------------------------

  This unit contains functions to prepare SMTP mail messages or SendMail
  messages. Random boundary creator function, and a file content encoder is
  included in this unit.

 ------------------------------------------------------------------------------
  Developer Notes
 ------------------------------------------------------------------------------

  [ 14/OCT/2005 -L505 ]

   -created unit

   -note: this unit is a very similar to the PWUMailPrep unit included in
          Pascal Web Unit project (PWU). At a later point in time, the two units
          will be merged so that there is less maintenance. PWU will just ship
          with it's own copy of this unit.
          
 ------------------------------------------------------------------------------
  Developer Todo
 ------------------------------------------------------------------------------

 ------------------------------------------------------------------------------
  Contributors/Authors:
 ------------------------------------------------------------------------------
   Lars (L505)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
}



unit SendMailPrep;


{$DEFINE EXTRA_SECURE}

{$IFDEF FPC}{$MODE OBJFPC}{$H+}
    {$IFDEF EXTRA_SECURE}
     {$R+}{$Q+}{$CHECKPOINTER ON}
    {$ENDIF}
{$ENDIF}


{------------------------------------------------------------------------------}
interface
{------------------------------------------------------------------------------}

uses
  base64enc,
  sysutils;


{------------------------------------------------------------------------------}
{--------- PUBLIC PROCEDURE/FUNCTION DECLARATIONS -----------------------------}
{------------------------------------------------------------------------------}

  function PrepEmailBoundary: string;

  function PrepFileContents(filename: string): string;


//  END OF PUBLIC PROCEDURE/FUNCTION DECLARATIONS
{------------------------------------------------------------------------------}


{------------------------------------------------------------------------------}
implementation
{------------------------------------------------------------------------------}


// prepares a randomdly generated boundary for separating files and text in the
// message
function PrepEmailBoundary: string;
const
  CHARSET = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
  MAX = 20; //the maximum length of the randomized string
var
  iLoc: longword;
begin
  result:= '';
  SetLength(result, MAX);
  for iLoc:= 1 to MAX do
  begin
    randomize;
    result[iLoc] := CHARSET[random(61) + 1];
  end;
end;


// prepares file attachment into a string (base 64 encoded)
function  PrepFileContents(FileName: string): string;
var
  TheFile: file of char;
  temp: string;
  iLoc,                         //Local loop
  len,
  count: longword;
  buffer: array[1..4096] of char; //buffer to hold contents
  
begin
  result:= '';
  FileMode:= fmOpenRead; //open it as read only since web files should not not have write permissions
  assign(TheFile, filename);
  reset(TheFile);
  temp:= '';
  count:= 0;
  while not eof(TheFile) do
  begin
    blockread(TheFile, buffer, sizeof(buffer), len);
    SetLength(temp, count + len);
    for iLoc:= 1 to len do
      temp[count + iLoc]:= buffer[iLoc];
    inc(count, len);
  end;
  close(TheFile);
  result:= base64_encode(temp);

end;



end.


